import { getThirdUserPlatForm } from "../../api/request";
import { throttle } from "../../utils/utils";
import create from "dd-store";
create.Component({
  mixins: [],
  data: {
    $data: null,
    userInfo: {},
    relatedAppList: [],
    relatedAppPlatformList: []
  },
  props: {},
  didMount() {
    this.setData({
      userInfo: JSON.parse(getApp().globalData.userInfo)
    });
    this.getData();
  },
  didUpdate() {
    if (typeof this.$store.data.relatedAppNeedUpdate === "object") {
      let relatedAppList = this.data.relatedAppList;
      let relatedAppPlatformList = this.data.relatedAppPlatformList;
      relatedAppList.push({
        userName: this.$store.data.relatedAppNeedUpdate.name,
        platform: this.$store.data.relatedAppNeedUpdate.platform
      });
      relatedAppPlatformList.push(
        this.$store.data.relatedAppNeedUpdate.platform
      );
      this.setData({
        relatedAppList: relatedAppList,
        relatedAppPlatformList: relatedAppPlatformList
      });
      this.$store.data.relatedAppNeedUpdate = "";
      this.update();
    } else if (this.$store.data.relatedAppNeedUpdate === "1") {
      this.$store.data.relatedAppNeedUpdate = "";
      this.update();
      this.getData();
    }
  },
  didUnmount() {},
  methods: {
    getData() {
      getThirdUserPlatForm().then(res => {
        let relatedAppPlatformList = [];
        res.data.data.forEach(item => {
          relatedAppPlatformList.push(item.platform);
        });
        this.setData({
          relatedAppList: res.data.data,
          relatedAppPlatformList: res.data.data.map(it => it.platform)
        });
      });
    },
    preventSort() {
      return false;
    },
    toAppDetails(e) {
      dd.navigateTo({
        url: `./../appDetails/appDetails?userName=${e.target.dataset.name}&platform=${e.target.dataset.platform}`
      });
    }
  }
});
