import { addSchedule, getUserScheduleInTime } from '../../api/request.js'
import { throttle, getInterTime } from './../../utils/utils.js'
import { checkFullScren } from "../../utils/checkFullScren";
import create from 'dd-store'
create.Page({
  data: {
    $data: null,
    // 传给组件list 的所有数据 comListData
    comListData: {
      repeatList: [
        { id: 0, text: '不重复', icon: 'iconicon_cycle', repeatable: 0, recurrenceModel: { model: 'no_repeat' } },
        { id: 1, text: '每天', icon: '', repeatable: 1, recurrenceModel: { model: 'daily', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: null } },
        { id: 2, text: '每周', icon: '', repeatable: 1, recurrenceModel: { model: 'weekly', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: ['MO'] } },
        { id: 3, text: '每周的工作日', icon: '', repeatable: 1, recurrenceModel: { model: 'weekly', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: ['MO', 'TU', 'WE', 'TH', 'FR'] } },
        { id: 4, text: '每月', icon: '', repeatable: 1, recurrenceModel: { model: 'absolute_Monthly', daysOfMonth: ['23'], interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: null } }
      ],
      meetingWayList: [
        // { id: 0, text: 'Webex meeting', imageUrl: '../../assests/Webex.png', meetingWayModel: { model: 'webex' } },
        { id: 0, text: 'Zoom Meeting', imageUrl: '../../assests/Zoom.png', meetingWayModel: { model: 'zoom' } },
        { id: 1, text: '钉钉', imageUrl: '../../assests/dingding.png', meetingWayModel: { model: 'dingtalk' } }
      ],
      comSelectListId: 0,
      meetingWayModelId: null,
      iconType: 'icon'
    },
    // 传给组件 hList 水平排列  所有数据 comHListData
    comHListData: {
      contactData: [
        { id: 0, text: '钉钉联系人', imageUrl: '../../assests/dingContact.png' },
        { id: 1, text: '手动添加邮箱', imageUrl: '../../assests/emailContact.png' }
      ]
    },
    title: ``,
    repeatable: 0,
    recurrenceModel: { model: 'no_repeat' },
    isShowRemark: false,
    repeatWeek: ['SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA'],
    popupTitle: '会议重复',
    popupShow: false,
    comType: '',
    remark: '',
    comTimeType: '',
    meetingWayModel: { model: null },
    weekList: ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
    week: '',
    isAcrossDay: false,
    conflictPeople: [],
    placeholder: '',
    isIPX: false
  },

  showPop(event) {
    this.setData({
      show: true
    })
  },
  closePop() {
    this.setData({
      show: false
    })

  },
  Complete(data) {
    this.closePop();
  },
  onLoad() {
    dd.setNavigationBar({
      title: `创建会议`
    })
    this.setData({
      isIPX: checkFullScren(),
      placeholder: `${getApp().globalData.name}创建的会议`
    })
    this.reset()
  },
  onShow() {
    if (this.$store.data.participatorList.length > 1) {
      this.conflictPeople()
    }
    setTimeout(() => {
      this.update()
    }, 100)
  },
  // 添加描述
  addRemark() {
    this.setData({
      isShowRemark: true
    })
    this.update()

  },
  // 输入框输入事件
  onInput(event) {
    switch (event.target.dataset.type) {
      case 'title':
        this.setData({
          title: event.detail.value
        })
        break
      case 'remark':
        this.setData({
          remark: event.detail.value
        })
        break
    }
  },
  // 初始化
  reset() {
    this.$store.resetData()
    this.$store.data.startTime = this.getTimes()
    this.$store.data.endTime = this.getTimes(new Date().setMinutes(new Date().getMinutes() + 30))
    this.update()
    this.resetRepeatList()
    this.acrossDay(this.$store.data.startTime, this.$store.data.endTime)
  },
  // 跳转下一页
  nextPage(event) {
    switch (event.target.dataset.nextPage) {
      case 'location':
        dd.navigateTo({ url: './../place/place' })
        break
      case 'participantsDetail':
        dd.navigateTo({ url: './../participantsDetail/participantsDetail' })
        break
    }
  },
  // 所有的关闭操作
  close(event) {
    switch (event.target.dataset.close) {
      case 'location':
        this.$store.data.locationName = ''
        this.$store.data.roomId = ''
        this.update()
        break
      case 'meetingWayModel':
        this.setData({
          'comListData.meetingWayModelId': null,
          meetingWayModel: null
        })
    }
  },
  // 关闭popup 点击mark
  closePopup() {
    this.setData({
      popupShow: false
    })
  },
  // 选择循环机制 选择会议方式  选择时间  出现popup弹窗
  showPopup(event) {
    let iconType = ''
    let popupTitle = ''
    switch (event.currentTarget.dataset.type) {
      case 'meetingWayModel':
        iconType = 'image'
        popupTitle = '选择会议方式'
        break
      case 'repeat':
        iconType = 'icon'
        popupTitle = '会议重复'
        break
      case 'participator':
        popupTitle = '选择参会人'
        break
      case 'time':
        popupTitle = '选择会议时间'
        break
    }
    this.setData({
      popupTitle: popupTitle,
      popupShow: true,
      comType: event.currentTarget.dataset.type,
      'comListData.iconType': iconType
    })

  },
  resetRepeatList() {
    let index = 0
    let repeatList = []
    for (let value of this.data.comListData.repeatList) {
      if (index) {
        value.recurrenceModel.initialTime = this.$store.data.startTime.replace(/\//g, "-").substring(0, 10)
        value.recurrenceModel.terminateTime = this.getTwoYearToday(this.$store.data.startTime)
        if (index === 2) {
          value.recurrenceModel.weekDayList = [this.data.repeatWeek[new Date(this.$store.data.startTime).getDay()]]
        } else if (index === 4) {
          value.recurrenceModel.daysOfMonth = [this.$store.data.startTime.replace(/\//g, "-").substring(8, 10)]
        }
      }
      repeatList.push(value)
      index++
    }
    this.setData({
      'comListData.repeatList': repeatList,
      week: this.data.weekList[new Date(this.$store.data.startTime).getDay()]
    })

  },
  // 选择完comList后的回调
  selectComList(event) {
    switch (this.data.comType) {
      case 'meetingWayModel':
        this.setData({
          'comListData.meetingWayModelId': event.currentTarget.dataset.item.id,
          popupShow: false,
          meetingWayModel: this.data.comListData.meetingWayList[event.currentTarget.dataset.item.id].meetingWayModel
        })
        break;
      case 'repeat':
        this.resetRepeatList()
        this.setData({
          popupShow: false,
          'comListData.comSelectListId': event.currentTarget.dataset.item.id,
          repeatable: event.currentTarget.dataset.item.repeatable,
          recurrenceModel: event.currentTarget.dataset.item.recurrenceModel
        })
        this.conflictPeople()
        break;
    }
  },
  // 选择完水平 HList 的回调
  selectComHList(event) {
    switch (event.currentTarget.dataset.item.id) {
      case 0:
        this.addParticipator()
        this.setData({
          popupShow: false
        })
        break;
      case 1:
        this.setData({
          popupShow: false
        })
        dd.navigateTo({ url: './../outLookContact/outLookContact' })
        break;
    }
  },
  // 获取两年后的今天
  getTwoYearToday(startTime) {
    let date = new Date(startTime)
    date.setYear(date.getFullYear() + 2)
    let year = date.getFullYear();
    let month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1;
    let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate()
    return year + '-' + month + '-' + day
  },
  // 添加参会人
  addParticipator: throttle(function () {
    const _that = this
    let require = []
    let select = []
    let outLookConcat = []
    for (let participator of _that.$store.data.participatorList) {
      if (participator.platform === 'outlook') {
        outLookConcat.push(participator)
      }
    }
    select = this.$store.data.participatorUserId
    require = [getApp().globalData.userid]
    select = _that.selectedelRequired(require, select).pickedUsers
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户    s
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        let participatorList = []
        let participatorUserId = []
        participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
        participatorUserId.push(getApp().globalData.userid)
        res.users.forEach((item, index) => {
          participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
          participatorUserId.push(item.userId)
        })
        participatorList = _that.setArrary(participatorList.concat(outLookConcat))
        participatorUserId = [...new Set(participatorUserId)]
        _that.$store.data.participatorList = participatorList
        _that.$store.data.participatorUserId = participatorUserId
        _that.update()
        _that.conflictPeople()
      },
      fail: function (err) {
      }
    })

  }),
  // 已选用户去中去掉必选用户
  selectedelRequired(req, pic) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  },
  // 数组 去重
  setArrary(arr) {
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 点击完成
  onComplete(event) {
    this.$store.data.startTime = `${event.startTime}:00`
    this.$store.data.endTime = `${event.endTime}:00`
    this.update()
    this.acrossDay(this.$store.data.startTime, this.$store.data.endTime)
    this.setData({
      popupShow: false,
      week: this.data.weekList[new Date(this.$store.data.startTime).getDay()],
    })
    this.conflictPeople()
    this.resetRepeatList()
  },
  addSchedule: throttle(function () {
    let data = {
      title: this.data.title || `${getApp().globalData.name}创建的会议`,
      location: {
        longitude: '10',
        latitude: '10',
        locationName: this.$store.data.locationName
      },
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      meetingRoomId: this.$store.data.roomId,
      scheduleType: this.$store.data.roomId ? 'meeting' : 'common',
      participatorList: !!this.$store.data.participatorList.length ? this.$store.data.participatorList : [{ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' }],
      repeatable: this.data.repeatable,
      remark: this.data.remark,
      recurrenceModel: this.data.recurrenceModel,
      meetingRoomId: this.$store.data.roomId,
      meetingWayModel: this.data.meetingWayModel
    }
    addSchedule(data).then(res => {
      if (res.data.code === 0) {
        this.$store.data.tabBarIndex = '1'
        if (this.data.repeatable === 0) {
          this.$store.data.onceMeetingContent = {
            startTime: new Date(this.$store.data.startTime),
            endTime: new Date(this.$store.data.endTime),
            confirmAttendance: res.data.data.confirmAttendance,
            title: res.data.data.title,
            id: res.data.data.id
          }
        } else {
          this.$store.data.indexNeedUpdate = true
        }
        console.log(this.$store.data.onceMeetingContent)

        this.update()
        dd.navigateBack({
          delta: 1
        })
      }
    })

  }),
  // 获取时间参数
  getTimes(time = new Date()) {
    let date = getInterTime(new Date(time))
    let year = date.getFullYear()
    let month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1
    let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate()
    let hour = date.getHours() < 10 ? '0' + date.getHours() : date.getHours()
    let miunutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()

    return `${year}/${month}/${day} ${hour}:${miunutes}:00`
  },
  // 是否跨天
  acrossDay(time1, time2) {
    let isAcrossDay = ''
    if (JSON.stringify(this.getTimes(time1).substring(0, 10)) === JSON.stringify(this.getTimes(time2).substring(0, 10))) {
      isAcrossDay = false
    } else {
      isAcrossDay = true
    }
    this.setData({
      isAcrossDay: isAcrossDay
    })
  },
  // 会议冲突
  conflictPeople() {
    let userIds = []
    for (let value of this.$store.data.participatorList) {
      userIds.push(value.userId)
    }
    let data = {
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        const arr = res.data.data[value].filter(function (item) {
          return item.confirmAttendance === 1
        })
        if (arr.length > 0) {
          conflictPeople.push(value)
        }
      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  }
});
